#include "bitmap.h"

// ----------------------------------------------------------------
void init_bitmap_header(
	int pix_width,
	int pix_height,
	struct tBitmapHeader * pheader)
{
	int nbytes_in_file;
	int nbytes_in_data;
	int padded_width_3 = ((pix_width * 3) + 3) & ~3;

	pheader->name[0]                  = 'B';
	pheader->name[1]                  = 'M';
	nbytes_in_file                    = sizeof(*pheader) + padded_width_3 * pix_height;
	pheader->nbytes_in_file_lo        = nbytes_in_file & 0xffff;
	pheader->nbytes_in_file_hi        = (nbytes_in_file >> 16) & 0xffff;
	pheader->zero1                    = 0;
	pheader->field2                   = 0x00360000;
	pheader->field3                   = 0x00280000;

	pheader->zero2                    = 0;
	pheader->image_width_in_pixels    = pix_width;
	pheader->zero3                    = 0;
	pheader->image_height_in_pixels   = pix_height;
	pheader->field4                   = 0x00010000;
	pheader->field5                   = 0x00000018;

	pheader->zero4                    = 0;
	nbytes_in_data                    = padded_width_3 * pix_height;
	pheader->nbytes_in_data_lo        = nbytes_in_data & 0xffff;
	pheader->nbytes_in_data_hi        = (nbytes_in_data >> 16) & 0xffff;
	pheader->field6                   = 0x0ec4;
	pheader->field7                   = 0x0ec40000;
	pheader->field8                   = 0x00000000;

	pheader->zero5                    = 0;
	pheader->zero6                    = 0;
}
