#include "lcg.h"

static long s1 = 1;
static long s2 = 1;

#define MODMULT(a,b,c,m,s) q = s/a; s = b*(s-a*q) - c*q; if (s<0) s+=m;

// ----------------------------------------------------------------
double combinedLCG(
	void)
{
	long q;
	long z;

	MODMULT(53668, 40014, 12211, 2147483563L, s1)
	MODMULT(52774, 40692,  3791, 2147483399L, s2)
	z = s1 - s2;
	if (z < 1)
		z += 2147483562;
	return z * 4.656613e-10;
}

// ----------------------------------------------------------------
void initLCG(
	long inits1,
	long inits2)
{
	s1 = inits1;
	s2 = inits2;
	
	if (s1 == 0)
		s1 = 1;
	if (s2 == 0)
		s2 = 1;
}
